From 6808d7b92022f0bbcbc91632777c5611ea42307e Mon Sep 17 00:00:00 2001
From: zubin <imzubin@localhost.localdomain>
Date: Jul 15 2019 17:12:53 +0000
Subject: [PATCH 8/18] added critpath


---

diff --git a/src/.vscode/tags b/src/.vscode/tags
new file mode 100644
index 0000000..888b37c
--- /dev/null
+++ b/src/.vscode/tags
@@ -0,0 +1,59 @@
+!_TAG_FILE_FORMAT	2	/extended format; --format=1 will not append ;" to lines/
+!_TAG_FILE_SORTED	1	/0=unsorted, 1=sorted, 2=foldcase/
+!_TAG_PROGRAM_AUTHOR	Darren Hiebert	/dhiebert@users.sourceforge.net/
+!_TAG_PROGRAM_NAME	Exuberant Ctags	//
+!_TAG_PROGRAM_URL	http://ctags.sourceforge.net	/official site/
+!_TAG_PROGRAM_VERSION	5.8	//
+BodhiClient	../bodhiCalls.py	/^from bodhi.client.bindings import BodhiClient$/;"	kind:namespace	line:1
+BodhiClient	../main.py	/^from bodhi.client.bindings import BodhiClient$/;"	kind:namespace	line:23
+FasProxyClient	../main.py	/^from fedora.client import FasProxyClient, openidbaseclient$/;"	kind:namespace	line:24
+LoginWindow.py	../LoginWindow.py	1;"	kind:file	line:1
+Main	../main.py	/^class Main():$/;"	kind:class	line:29
+Path	../main.py	/^from pathlib import Path$/;"	kind:namespace	line:9
+QtCore	../LoginWindow.py	/^from PyQt5 import QtCore, QtGui, QtWidgets$/;"	kind:namespace	line:10
+QtCore	../main.py	/^from PyQt5 import QtCore, QtGui, QtWidgets$/;"	kind:namespace	line:14
+QtCore	../main.py	/^from PySide2 import QtCore, QtGui, QtWidgets$/;"	kind:namespace	line:13
+QtCore	../window.py	/^from PyQt5 import QtCore, QtGui, QtWidgets$/;"	kind:namespace	line:10
+QtGui	../LoginWindow.py	/^from PyQt5 import QtCore, QtGui, QtWidgets$/;"	kind:namespace	line:10
+QtGui	../main.py	/^from PyQt5 import QtCore, QtGui, QtWidgets$/;"	kind:namespace	line:14
+QtGui	../main.py	/^from PySide2 import QtCore, QtGui, QtWidgets$/;"	kind:namespace	line:13
+QtGui	../window.py	/^from PyQt5 import QtCore, QtGui, QtWidgets$/;"	kind:namespace	line:10
+QtWidgets	../LoginWindow.py	/^from PyQt5 import QtCore, QtGui, QtWidgets$/;"	kind:namespace	line:10
+QtWidgets	../main.py	/^from PyQt5 import QtCore, QtGui, QtWidgets$/;"	kind:namespace	line:14
+QtWidgets	../main.py	/^from PySide2 import QtCore, QtGui, QtWidgets$/;"	kind:namespace	line:13
+QtWidgets	../window.py	/^from PyQt5 import QtCore, QtGui, QtWidgets$/;"	kind:namespace	line:10
+Ui_Login	../LoginWindow.py	/^class Ui_Login(object):$/;"	kind:class	line:13
+Ui_Login	../main.py	/^from LoginWindow import Ui_Login$/;"	kind:namespace	line:18
+Ui_MainWindow	../main.py	/^from window import Ui_MainWindow$/;"	kind:namespace	line:17
+Ui_MainWindow	../window.py	/^class Ui_MainWindow(object):$/;"	kind:class	line:13
+__init__	../main.py	/^        def __init__(self):$/;"	kind:member	line:30
+app	../main.py	/^        app = Main()/;"	kind:variable	line:268
+bc	../bodhiCalls.py	/^bc = BodhiClient()$/;"	kind:variable	line:3
+bodhiCalls.py	../bodhiCalls.py	1;"	kind:file	line:1
+cache	../main.py	/^        def cache(self):$/;"	kind:member	line:165
+comment	../main.py	/^        def comment(self, update, comment, karma=0, critpath = None):$/;"	kind:member	line:176
+fetchList	../main.py	/^        def fetchList(self, cached_data):$/;"	kind:member	line:133
+json	../main.py	/^import json$/;"	kind:namespace	line:7
+literal_eval	../main.py	/^from ast import literal_eval$/;"	kind:namespace	line:10
+location_data	../main.py	/^location_data = str(Path.home()) + "\/.fgk"$/;"	kind:variable	line:26
+loginPopup	../main.py	/^        def loginPopup(self):$/;"	kind:member	line:96
+logout	../main.py	/^        def logout(self):$/;"	kind:member	line:120
+main.py	../main.py	1;"	kind:file	line:1
+next_page	../main.py	/^        def next_page(self):$/;"	kind:member	line:149
+openidbaseclient	../main.py	/^from fedora.client import FasProxyClient, openidbaseclient$/;"	kind:namespace	line:24
+os	../main.py	/^import os$/;"	kind:namespace	line:5
+populateComments	../main.py	/^        def populateComments(self, t):$/;"	kind:member	line:210
+postKarma	../main.py	/^        def postKarma(self):$/;"	kind:member	line:186
+pprint	../bodhiCalls.py	/^import pprint$/;"	kind:namespace	line:2
+pprint	../main.py	/^import pprint$/;"	kind:namespace	line:8
+previous_page	../main.py	/^        def previous_page(self):$/;"	kind:member	line:155
+retranslateUi	../LoginWindow.py	/^    def retranslateUi(self, Login):$/;"	kind:member	line:57
+retranslateUi	../window.py	/^    def retranslateUi(self, MainWindow):$/;"	kind:member	line:304
+save	../main.py	/^        def save(self):$/;"	kind:member	line:101
+searching	../main.py	/^        def searching(self):$/;"	kind:member	line:256
+selected	../main.py	/^        def selected(self):$/;"	kind:member	line:227
+setupUi	../LoginWindow.py	/^    def setupUi(self, Login):$/;"	kind:member	line:14
+setupUi	../window.py	/^    def setupUi(self, MainWindow):$/;"	kind:member	line:14
+sys	../main.py	/^import sys$/;"	kind:namespace	line:6
+verifyLogin	../main.py	/^        def verifyLogin(self):$/;"	kind:member	line:109
+window.py	../window.py	1;"	kind:file	line:1
diff --git a/src/main.py b/src/main.py
index cbc489f..fcefa22 100755
--- a/src/main.py
+++ b/src/main.py
@@ -21,6 +21,7 @@ from LoginWindow import Ui_Login
 
 #  import Fedora libs
 from bodhi.client.bindings import BodhiClient
+from fedora.client import FasProxyClient, openidbaseclient
 
 location_data = str(Path.home()) + "/.fgk"
 
@@ -30,10 +31,12 @@ class Main():
                 
                 self.username = None
                 self.password = None
+                self.login = False
+                
                 # init application
                 app = QtWidgets.QApplication(sys.argv)
-                self.error = QtWidgets.QApplication([])
                 MainWindow = QtWidgets.QMainWindow()
+                self.error = QtWidgets.QApplication([])
                 self.ui = Ui_MainWindow()
                 self.ui.setupUi(MainWindow)
                 
@@ -61,21 +64,31 @@ class Main():
                 # listeners loginPopup
                 self.ui_login.saveButton.clicked.connect(self.save)
 
-                # fedora Release
-                self.fedoraRelease = ["30","29"]
-                self.ui_login.fedoraReleases.addItems(self.fedoraRelease)
                 
                 # Get Login and fedora version
                 self.loginPopup()
 
                 # Bodhi
                 self.bc = BodhiClient()
-
+                self.fas = FasProxyClient()
 
                 self.query_args = {}
                 self.query_args['rows_per_page'] = 30
                 self.query_args['page'] = 1
-                self.query_args['releases'] = "30"
+                self.query_args['releases'] = ""
+                
+                # fedora Release
+                self.fedoraRelease = self.bc.get_releases()
+                self.release = []
+                for i in self.fedoraRelease['releases']:
+                        self.release.append(i['name'])
+                self.ui_login.fedoraReleases.addItems(self.release)
+
+                # setting buttons
+                self.ui.pushButton.setEnabled(0)
+                self.ui.loginButton.clicked.connect(self.loginPopup)
+                # Misc
+                self.critpath = False
 
                 MainWindow.show()
                 sys.exit(app.exec_())
@@ -91,33 +104,30 @@ class Main():
                 
                 self.username = self.ui_login.Username.text()
                 self.password = self.ui_login.Password.text()
-                self.query_args['releases'] = self.ui_login.fedoraReleases.currentText()     
-                print(self.username, self.password )
-                
-
-
+                self.query_args['releases'] = self.ui_login.fedoraReleases.currentText()
                 self.Login.close()
-
-        def postKarma(self):
-                t = self.ui.listWidget.selectedItems()
-                if (self.username == None or self.password == None):
-                                print("e")
-                                error_dialog = QtWidgets.QErrorMessage()
-                                error_dialog.showMessage("login first")
-                                # self.error.exec_()
+                self.verifyLogin()
+        
+        def verifyLogin(self):
+                verification = self.fas.verify_password(self.username, self.password)
+                if(verification):
+                        self.ui.usernamLable.setText(self.username)
+                        self.ui.loginButton.setText("logout")
+                        self.ui.loginButton.clicked.connect(self.logout)
+                        self.login = True
+                        self.ui.pushButton.setEnabled(1)
                 else:
-                        try:
-                                self.bc1 = BodhiClient(base_url='https://bodhi.fedoraproject.org/', username=self.username, password=self.password)
-                                self.bc1.comment(t[0].text(), self.ui.commentEdit.toPlainText(), self.ui.karmaBox.currentText())
-                                print(self.username,self.password)
-                        
-                        except Exception as e:
-                                print(e)
-                                error_dialog = QtWidgets.QErrorMessage()
-                                error_dialog.showMessage(str(e))
-                                # self.error.exec_()
-                
-                pass
+                        self.loginPopup()
+
+        def logout(self):
+                self.username = None
+                self.password = None
+                self.login = None
+                self.ui.usernamLable.setText("Username")
+                self.ui.loginButton.setText("login")
+                self.ui.loginButton.clicked.connect(self.loginPopup)
+                self.ui.pushButton.setEnabled(0)
+
 
         
         
@@ -142,6 +152,7 @@ class Main():
                 self.query_args["page"] = int(self.query_args["page"]) + 1
                 self.ui.PageNum.setText(str(self.query_args["page"]))
                 self.directory = location_data + "/" +self.query_args['releases'] + '/'+ str(self.query_args['page']) + ".json"
+                
                 self.fetchList(self.directory)
 
         def previous_page(self):
@@ -164,6 +175,41 @@ class Main():
                         f.write(json.dumps(self.data))
                 pass
 
+        # custom comment function for critpath
+        def comment(self, update, comment, karma=0, critpath = None):
+                try:
+                        if (critpath == None):
+                                x = self.bc.send_request('comments/', verb='POST', auth=True, data={'update': update, 'text': comment, 'karma': karma, 'csrf_token': self.bc1.csrf()})
+                        else:
+                                x = self.bc.send_request('comments/', verb='POST', auth=True, data={'update': update, 'text': comment, 'karma': karma, 'karma_critpath': critpath ,'csrf_token': self.bc1.csrf()})
+                        return(x)
+                except Exception as e:
+                        print(e)
+
+        def postKarma(self):
+                t = self.ui.Package_breif.text()
+                print(t)
+                if (not self.login):
+                                error_dialog = QtWidgets.QErrorMessage()
+                                error_dialog.showMessage("login before posting karma")
+                                error_dialog.exec_()
+                else:
+                        try:
+                                if(self.critpath == True):
+                                        self.bc1 = BodhiClient(base_url='https://bodhi.fedoraproject.org/', username=self.username, password=self.password)
+                                elif(self.critpath == False):
+                                        self.bc1 = BodhiClient(base_url='https://bodhi.fedoraproject.org/', username=self.username, password=self.password)
+                                response = self.comment(t, self.ui.commentEdit.toPlainText(), self.ui.karmaBox.currentText())
+                                print(self.username,response)
+                        
+                        except Exception as e:
+                                print(e)
+                                error_dialog = QtWidgets.QErrorMessage()
+                                error_dialog.showMessage(str(e))
+                                error_dialog.exec_()
+
+
+
         # selecting the update
 
         # populates comments in the section
@@ -173,13 +219,16 @@ class Main():
                                 comment = QtWidgets.QTreeWidgetItem()
                                 comment.setText(0, str(comments['id']))
                                 comment.setText(1, str(comments['karma']))
-                                comment.setText(2, str(comments['user']['name']))
-                                comment.setText(3, str(comments['text']))
+                                comment.setText(2, str(comments['karma_critpath']))
+                                comment.setText(3, str(comments['user']['name']))
+                                comment.setText(4, str(comments['text']))
                                 self.ui.treeWidget_comment.insertTopLevelItem(0,comment)
                 except:
                         pass
         
 
+
+
         # changes the display text on selection.
         def selected(self):
                 try:
@@ -203,7 +252,18 @@ class Main():
                                         elif(p["type"] == "security"):
                                                 self.ui.UpdateType.setPixmap(self.security)                                                
                                         elif(p["type"] == "newpackage"):
-                                                self.ui.UpdateType.setPixmap(self.newpackage)                                                
+                                                self.ui.UpdateType.setPixmap(self.newpackage)
+                                        
+                                        if(p['critpath'] == True):
+                                                self.ui.critpathBox.setVisible(0)
+                                                self.ui.critpathText.setVisible(0)
+                                                self.critpath = True
+                                        if(p['critpath'] == False):
+                                                self.ui.critpathBox.setVisible(1)
+                                                self.ui.critpathText.setVisible(1)
+                                                self.critpath = False
+
+
                 except Exception as e:
                         print(e)
                         pass
@@ -211,10 +271,14 @@ class Main():
         
         # using the search bar
         def searching(self):
-                self.ui.listWidget.clear()
-                for p in self.data['updates']:
-                        if str(self.ui.lineEdit.text()) in p['title']:
-                                self.ui.listWidget.addItem(p['title'])
+                try:
+                        self.ui.listWidget.clear()
+                        for p in self.data['updates']:
+                                if str(self.ui.lineEdit.text()) in p['title']:
+                                        self.ui.listWidget.addItem(p['title'])
+                        pass
+                except Exception as e:
+                        print(e)
 
 
 if __name__ == "__main__":
